/*
    *
    * Copyright 2019 Britanicus <marcusbritanicus@gmail.com>
    *
    * This file is a part of DesQ project <https://gitlab.com/desq/>
    *

    *
    * This file was originally taken from LXQt project
    * <https://github.com/lxqt/lxqt-panel>
    * Several modifications have been made to suit the needs of DesQ
    * Any and all bug reports are to be filed with DesQ and not LXQt
    *

    *
    * This program is free software; you can redistribute it and/or modify
    * it under the terms of the GNU General Public License as published by
    * the Free Software Foundation; either version 3 of the License, or
    * (at your option) any later version.
    *

    *
    * This program is distributed in the hope that it will be useful,
    * but WITHOUT ANY WARRANTY; without even the implied warranty of
    * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    * GNU General Public License for more details.
    *

    *
    * You should have received a copy of the GNU General Public License
    * along with this program; if not, write to the Free Software
    * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
    * MA 02110-1301, USA.
    *
*/

#include "SNIAsync.hpp"

SniAsync::SniAsync( QString serv, QString path, QDBusConnection conn, QObject *parent ) : QObject( parent ) {

    mSni = new StatusNotifierItem( serv, path, conn, parent );

    //forward StatusNotifierItem signals
    connect( mSni, &StatusNotifierItem::NewAttentionIcon, this, &SniAsync::NewAttentionIcon );
    connect( mSni, &StatusNotifierItem::NewIcon, this, &SniAsync::NewIcon );
    connect( mSni, &StatusNotifierItem::NewOverlayIcon, this, &SniAsync::NewOverlayIcon );
    connect( mSni, &StatusNotifierItem::NewStatus, this, &SniAsync::NewStatus );
    connect( mSni, &StatusNotifierItem::NewTitle, this, &SniAsync::NewTitle );
    connect( mSni, &StatusNotifierItem::NewToolTip, this, &SniAsync::NewToolTip );
}

QDBusPendingReply<QDBusVariant> SniAsync::asyncPropGet( QString const & property ) {

    QDBusMessage msg = QDBusMessage::createMethodCall(
        mSni->service(),
        mSni->path(),
        QLatin1String( "org.freedesktop.DBus.Properties" ),
        QLatin1String( "Get" )
    );

    msg << mSni->interface() << property;
    return mSni->connection().asyncCall( msg );
}

QDBusPendingReply<> SniAsync::Activate(int x, int y) {

    return mSni->Activate(x, y);
};

QDBusPendingReply<> SniAsync::ContextMenu(int x, int y) {

    return mSni->ContextMenu(x, y);
};

QDBusPendingReply<> SniAsync::Scroll(int delta, const QString &orientation) {

    return mSni->Scroll(delta, orientation);
};

QDBusPendingReply<> SniAsync::SecondaryActivate(int x, int y) {

    return mSni->SecondaryActivate(x, y);
};
